include "common.gs"
include "Signal.gs"
include "Junction.gs"
include "gs.gs"

class JRule {
 define int SPEED_FULL=0;
 define int SPEED_100=1;
 define int SPEED_60=2;
 define int SPEED_40=3;
 define int SPEED_0=4;
 define int SPEED_Zs1=5;
 define int SPEED_Ra12=6;
 define int SPEED_Zs8=7;

 public Junction[] junc=new Junction[0];
 public string[] njunc=new string[0];
 public int[] dir=new int[0];
 public int limit=SPEED_FULL;
 public bool zs7=false;
 public Signal nextSignal;
 public string nextSignalName;
 public bool nextSignalScripted=false;

 public Soup GetProperties(void) {
  Soup db=Constructors.NewSoup();
  db.SetNamedTag("num.j",junc.size());
  if (junc.size()) {
   db.SetNamedTag("limit",limit);
   db.SetNamedTag("nextSignalName",nextSignalName);
   db.SetNamedTag("zs7",zs7);
   int i;
   for (i=0; i<junc.size(); i++) {
    db.SetNamedTag("junc."+i,njunc[i]);
    db.SetNamedTag("dir."+i,dir[i]);
   }
  }
  return db;
 }

 public void SetProperties(Soup db) {
  int n=db.GetNamedTagAsInt("num.j",0);
  junc=new Junction[n];
  njunc=new string[n];
  dir=new int[n];
  if (n) {
   limit=db.GetNamedTagAsInt("limit",0);
   nextSignalName=db.GetNamedTag("nextSignalName");
   zs7=db.GetNamedTagAsInt("zs7");
   int i;
   for (i=0;i<n;i++) {
    njunc[i]=db.GetNamedTag("junc."+i);
    dir[i]=db.GetNamedTagAsInt("dir."+i,3);
   }
  }
 }

 public void Setup(void) {
  int i;
  for (i=0; i<njunc.size(); i++) {
   junc[i]=cast<Junction>Router.GetGameObject(njunc[i]);
  }
  nextSignal=cast<Signal>Router.GetGameObject(nextSignalName);
 }

};

class sperrsignal isclass Signal {
 Soup settings;
 StringTable ST;
 Asset rotlicht,gelblicht,gruenlicht,weisslicht;
 JRule[] rules=new JRule[0];
 int defaultLimit;
 int nextLimit;
 int thisLimit;
 int maxSpeed=-1;
 bool zs7=false;
 string name;
 Signal nextSignal;
 string nextSignalName;
 bool nextSignalScripted;

 bool ersatzrot=false;
 Browser mb;
 define int SPEED_FULL=0;
 define int SPEED_100=1;
 define int SPEED_60=2;
 define int SPEED_40=3;
 define int SPEED_0=4;
 define int SPEED_Zs1=5;
 define int SPEED_Ra12=6;
 define int SPEED_Zs8=7;

 int[] speedlimits=new int[SPEED_Zs8+1];
 string[] names=new string[SPEED_Zs8+1];

// HLSignal[] subscribers=new HLSignal[0];
 MapObject[] subscribers=new MapObject[0];

public void ApplySpeedLimitForStateEx(int state)
	{
// Dummy-Routine, um die Trainz-interne Geschwindigkeitssetzung-Routine auszuschalten,
// welche unsere Geschwindigkeit berschreiben wrde
	}

 void SwitchOffAllLights(void) {
  SetFXCoronaTexture("1",null);
  SetFXCoronaTexture("2",null);
  SetFXCoronaTexture("3",null);
  SetFXCoronaTexture("4",null);
  SetFXCoronaTexture("5",null);
  SetFXCoronaTexture("6",null);
  SetFXCoronaTexture("8",null);
  if (settings.GetNamedTagAsInt("speed60")) {
   SetFXCoronaTexture("9",null);
   SetFXCoronaTexture("10",null);
   SetFXCoronaTexture("11",null);
   SetFXCoronaTexture("12",null);
  }
  if (settings.GetNamedTagAsInt("speed100")) {
   SetFXCoronaTexture("13",null);
   SetFXCoronaTexture("14",null);
   SetFXCoronaTexture("15",null);
   SetFXCoronaTexture("16",null);
  }
  if (settings.GetNamedTagAsInt("speedZs1")) {
   SetFXCoronaTexture("19",null);
  }
  if (settings.GetNamedTagAsInt("speedRa12")) {
   SetFXCoronaTexture("17",null);
   SetFXCoronaTexture("18",null);
  }
  if (settings.GetNamedTagAsInt("speedZs8")) {
   SetFXCoronaTexture("20",null);
   SetFXCoronaTexture("21",null);
   SetFXCoronaTexture("22",null);
   SetFXCoronaTexture("23",null);
   SetFXCoronaTexture("24",null);
  }

  if (settings.GetNamedTagAsInt("isZs7")) {
   SetFXCoronaTexture("25",null);
   SetFXCoronaTexture("26",null);
   SetFXCoronaTexture("27",null);
   SetFXCoronaTexture("28",null);
   SetFXCoronaTexture("29",null);
  }
 }

 void NotifySubscribers(void) {
  int i;
  for(i=0;i<subscribers.size();i++) {
   PostMessage(subscribers[i],"HLSpeedNotify",thisLimit,0);
  }
 }

 int FindRuleIndex(void) {
  int c;
  int l;
  bool hit=false;
  l=-1;
  if (rules.size()>0) {
   for (c=0; c<rules.size(); c++) {
    hit=(rules[c].junc.size()>0);
    int j;
    for (j=0; j<rules[c].junc.size(); j++) {
     if (rules[c].junc[j]) {
      hit=hit and (rules[c].junc[j].GetDirection()==rules[c].dir[j]);
     } else {
      hit=false;
     }
    }
    if (hit) {l=c;}
   }
  }
  return l;
 }
 int FindLimit(void) {
  int idx=FindRuleIndex();
  if (idx==-1) { return defaultLimit; }
  return rules[idx].limit;
 }
 bool FindZs7(void) {
  int idx=FindRuleIndex();
  if (idx==-1) { return zs7; }
  return rules[idx].zs7;
 }
 Signal FindSignal(void) {
  int idx=FindRuleIndex();
  if (idx==-1) { return nextSignal; }
  return rules[idx].nextSignal;
 }

 void StateChange(Message msg) {
  if (msg.src==me) {if (thisLimit!=SPEED_Ra12) {PostMessage(me,"HLSignal","Update",0);}}
  int idx=FindRuleIndex();
  Signal next;
  bool scripted;
  if (idx==-1) { next=nextSignal; scripted=nextSignalScripted;}
  else { next=rules[idx].nextSignal; scripted=rules[idx].nextSignalScripted; }
  if (next==msg.src) {
   if (!scripted) {
    switch (next.GetSignalState()) {
     case RED: nextLimit=SPEED_0; break;
     case YELLOW: nextLimit=SPEED_40; break;
     case GREEN: nextLimit=SPEED_FULL; break;
     default:;
    }
    if (thisLimit!=SPEED_Ra12) {PostMessage(me,"HLSignal","Update",0);}
   }
  }
 }

 public void Update(Message msg) {
  if (msg.src==me) {
   if (!ersatzrot and Math.Rand(0,1000)>998) { ersatzrot=true; }
   thisLimit=FindLimit();
   if (GetSignalState()==RED and thisLimit!=SPEED_Ra12) { thisLimit=SPEED_0; }
   SwitchOffAllLights();
   if (settings.GetNamedTagAsInt("isHome")) {
    if (!GetSignalOwner()) { SetSignalState(null,AUTOMATIC,""); }
    switch (thisLimit) {
     case SPEED_FULL:
      SetFXCoronaTexture("17",weisslicht);
      SetFXCoronaTexture("18",weisslicht);
      break;
     case SPEED_Ra12:
      SetFXCoronaTexture("17",weisslicht);
      SetFXCoronaTexture("18",weisslicht);
      break;
     case SPEED_0:
       SetFXCoronaTexture("5",rotlicht);
       SetFXCoronaTexture("6",rotlicht);
      break;
     default:;
    }
    if (thisLimit>=0 and thisLimit<speedlimits.size()) {
     if (thisLimit!=SPEED_0) {SetSpeedLimit(speedlimits[thisLimit]/3.6);}
//     if (thisLimit!=SPEED_0 and thisLimit!=SPEED_FULL) {SetSpeedLimit(speedlimits[thisLimit]/3.6);}
    }
    NotifySubscribers();
   }

   if (settings.GetNamedTagAsInt("isDistant")) {
    if (!(settings.GetNamedTagAsInt("isHome") and (thisLimit==SPEED_0 or thisLimit==SPEED_Zs1 or thisLimit==SPEED_Ra12))) {
     switch (nextLimit) {
      case SPEED_FULL:
      SetFXCoronaTexture("17",weisslicht);
      SetFXCoronaTexture("18",weisslicht);
       break;
      case SPEED_100:
      case SPEED_60:
      case SPEED_40:
      case SPEED_Ra12:
      SetFXCoronaTexture("17",weisslicht);
      SetFXCoronaTexture("18",weisslicht);
       break;
      case SPEED_Zs1:
      case SPEED_Zs8:
      case SPEED_0:
       SetFXCoronaTexture("5",rotlicht);
       SetFXCoronaTexture("6",rotlicht);
       break;
      default:;
     }
    }
   }
  }
 }

 void KMNotify(Message msg) {
  int idx=FindRuleIndex();
  if (idx==-1) { nextSignalScripted=true; }
  else { rules[idx].nextSignalScripted=true; }
  if (msg.src==FindSignal()) {
   if (msg.minor=="Hp0") {
    nextLimit=SPEED_0;
   } else if (msg.minor=="Hp1") {
    nextLimit=SPEED_FULL;
   } else if (msg.minor=="Hp2") {
    nextLimit=SPEED_40;
   }
   PostMessage(me,"HLSignal","Update",0.3);
  }
 }

 void SubscribeTo(Signal sig) {
//  if (cast<HLSignal>sig) {
  if (cast<Signal>sig) {
   PostMessage(sig,"HLSignal","Subscribe",0);

	   PostMessage(sig,"KMSubscribe","",0);
	}
//  } else if (sig) {
//   PostMessage(sig,"KMSubscribe","",0);
//  }
 }

 void Setup(Message msg) {
  int i;
  for (i=0; i<rules.size(); i++) {
   rules[i].Setup();
   if (settings.GetNamedTagAsInt("isDistant")) {
    rules[i].nextSignalScripted=false;
    SubscribeTo(rules[i].nextSignal);
   }
  }
  nextSignal=cast<Signal>Router.GetGameObject(nextSignalName);
  if (settings.GetNamedTagAsInt("isDistant")) {
   nextSignalScripted=false;
   SubscribeTo(nextSignal);
  }
  thisLimit=FindLimit();
  if (name=="") {SetFXNameText("name0"," ");} else {SetFXNameText("name0",name);}
  PostMessage(me,"HLSignal","Update",0);
 }

 void JunctionToggled(Message msg) {
  int idx=FindRuleIndex();
  bool scripted;
  Signal sig;
  if (idx==-1) { sig=nextSignal; scripted=nextSignalScripted; } else {sig=rules[idx].nextSignal; scripted=rules[idx].nextSignalScripted; }
  if (!scripted and sig!=null) {
   switch (sig.GetSignalState()) {
    case RED: nextLimit=SPEED_0; break;
    case YELLOW: nextLimit=SPEED_40; break;
    case GREEN: nextLimit=SPEED_FULL; break;
    default:;
   }
  }
  PostMessage(me,"HLSignal","Update",0.5);
 }

 void Notify(Message msg) {
  int idx=FindRuleIndex();
  if (idx==-1) { nextSignalScripted=true; }
  else { rules[idx].nextSignalScripted=true; }
  if (FindSignal()==msg.src) {
   int limit=Str.ToInt(msg.minor);
   nextLimit=limit;
   PostMessage(me,"HLSignal","Update",0.5);
  }
 }

 void Subscribe(Message msg) {
  int i;
  for (i=0; i<subscribers.size(); i++) {
   if (msg.src==subscribers[i] or msg.src == me) { return; }
  }
  subscribers[subscribers.size()]=msg.src;
  PostMessage(msg.src,"HLSpeedNotify",thisLimit,0);
 }

 string MakeProperty(string link, string text) {
  string t;
  if (text=="") {t=ST.GetString("none"); } else {t=text;}
  return HTMLWindow.MakeLink("live://property/"+link,t);
 }

 string GetRuleHTML(int r) {
  string bgcol=ST.GetString("BGCOLOR");
  string bgcol2=ST.GetString("BGCOLOR2");
  string ret=HTMLWindow.StartTable();
  int j;
  ret=ret+HTMLWindow.MakeRow(
   HTMLWindow.MakeCell("   ")+
   HTMLWindow.MakeCell(ST.GetString("junction"),bgcol)+
   HTMLWindow.MakeCell(ST.GetString("junction.left"),bgcol)+
   HTMLWindow.MakeCell(ST.GetString("junction.forward"),bgcol)+
   HTMLWindow.MakeCell(ST.GetString("junction.right"),bgcol)+
   HTMLWindow.MakeCell(MakeProperty("del-rule/"+r,ST.GetString("del")),bgcol2)
  );
  for(j=0; j<rules[r].njunc.size(); j++) {
   ret=ret+HTMLWindow.MakeRow(
    HTMLWindow.MakeCell("   ")+
    HTMLWindow.MakeCell(MakeProperty("junc/"+r+"/"+j,rules[r].njunc[j]),bgcol2)+
    HTMLWindow.MakeCell(HTMLWindow.RadioButton("live://property/dir/"+r+"/"+j+"/"+Junction.DIRECTION_LEFT,rules[r].dir[j]==Junction.DIRECTION_LEFT),bgcol2)+
    HTMLWindow.MakeCell(HTMLWindow.RadioButton("live://property/dir/"+r+"/"+j+"/"+Junction.DIRECTION_FORWARD,rules[r].dir[j]==Junction.DIRECTION_FORWARD),bgcol2)+
    HTMLWindow.MakeCell(HTMLWindow.RadioButton("live://property/dir/"+r+"/"+j+"/"+Junction.DIRECTION_RIGHT,rules[r].dir[j]==Junction.DIRECTION_RIGHT),bgcol2)+
    HTMLWindow.MakeCell(MakeProperty("del-junc/"+r+"/"+j,ST.GetString("del")),bgcol2)
   );
  }
  ret=ret+HTMLWindow.MakeRow(HTMLWindow.MakeCell("   ")+HTMLWindow.MakeCell(MakeProperty("add-junc/"+r,ST.GetString("junction.add")),bgcol2+" colspan=5"));
  if (settings.GetNamedTagAsInt("isDistant")) {
   ret=ret+HTMLWindow.MakeRow(
    HTMLWindow.MakeCell("   ")+
    HTMLWindow.MakeCell(ST.GetString("nextSignal"),bgcol+" colspan=1")+
    HTMLWindow.MakeCell(MakeProperty("rule-nextSignal/"+r,rules[r].nextSignalName),bgcol2+" colspan=4")
   );
  }
  if (settings.GetNamedTagAsInt("isHome")) {
   ret=ret+HTMLWindow.MakeRow(
    HTMLWindow.MakeCell("   ")+
    HTMLWindow.MakeCell(ST.GetString("defaultLimit"),bgcol+" colspan=1")+
    HTMLWindow.MakeCell(MakeProperty("rule-limit/"+r,ST.GetString("fahrt."+names[rules[r].limit])),bgcol2+" colspan=4")
   );
  }
  if (settings.GetNamedTagAsInt("isZs7")) {
   ret=ret+HTMLWindow.MakeRow(
    HTMLWindow.MakeCell("   ")+
    HTMLWindow.MakeCell(ST.GetString("zs7"),bgcol+" colspan=1")+
    HTMLWindow.MakeCell(HTMLWindow.CheckBox("live://property/rule-zs7/"+r,rules[r].zs7),bgcol2+" colspan=4")
   );
  }
  ret=ret+HTMLWindow.EndTable();
  return ret;
 }

 public string GetDescriptionHTML(void) {
  string ret="<HTML><body>";
  string bgcol=ST.GetString("BGCOLOR");
  string bgcol2=ST.GetString("BGCOLOR2");

  ret=ret+HTMLWindow.StartTable();
  if (settings.GetNamedTagAsInt("isDistant")) {
   ret=ret+HTMLWindow.MakeRow(HTMLWindow.MakeCell(ST.GetString("nextSignal"),bgcol)+HTMLWindow.MakeCell(MakeProperty("nextSignal",nextSignalName),bgcol2));
  }
  if (settings.GetNamedTagAsInt("isHome")) {
   ret=ret+HTMLWindow.MakeRow(HTMLWindow.MakeCell(ST.GetString("platetext"),bgcol)+HTMLWindow.MakeCell(MakeProperty("name",name),bgcol2));
   ret=ret+HTMLWindow.MakeRow(HTMLWindow.MakeCell(ST.GetString("max.speed"),bgcol)+HTMLWindow.MakeCell(MakeProperty("maxSpeed",maxSpeed),bgcol2));
   ret=ret+HTMLWindow.MakeRow(HTMLWindow.MakeCell(ST.GetString("defaultLimit"),bgcol)+HTMLWindow.MakeCell(MakeProperty("defaultLimit",ST.GetString("fahrt."+names[defaultLimit])),bgcol2));
  }
  if (settings.GetNamedTagAsInt("isZs7")) {
   ret=ret+HTMLWindow.MakeRow(HTMLWindow.MakeCell(ST.GetString("zs7"),bgcol)+HTMLWindow.MakeCell(HTMLWindow.CheckBox("live://property/zs7",zs7),bgcol2));
  }
  if (rules.size()==0) {
   ret=ret+HTMLWindow.MakeRow(HTMLWindow.MakeCell(ST.GetString("rules.none"),bgcol)+HTMLWindow.MakeCell(MakeProperty("add-rule",ST.GetString("rules.add")),bgcol2));
  } else {
   int r;
   for(r=0; r<rules.size(); r++) {
    ret=ret+HTMLWindow.MakeRow(HTMLWindow.MakeCell(GetRuleHTML(r),"colspan=2"));
   }
   ret=ret+HTMLWindow.MakeRow(HTMLWindow.MakeCell(MakeProperty("add-rule",ST.GetString("rules.add")),bgcol2+" colspan=2"));
  }
  ret=ret+HTMLWindow.EndTable();

  ret=ret+"</Body></html>";
  return ret;
 }

 public string GetPropertyType(string id) {
  string[] tok=Str.Tokens(id,"/");
  if (tok[0]=="nextSignal") { return "list,1"; }
  else if (tok[0]=="rule-nextSignal") { return "list,1"; }
  else if (tok[0]=="rule-limit") { return "list"; }
  else if (tok[0]=="defaultLimit") { return "list"; }
  else if (tok[0]=="junc") { return "list,1"; }
  else if (tok[0]=="name") { return "string,0,4"; }
  else if (tok[0]=="maxSpeed") { return "int,0,300,10"; }
  return "link";
 }

 public string[] GetPropertyElementList(string id) {
  string[] tok=Str.Tokens(id,"/");
  string[] list=new string[0];
  if (tok[0]=="nextSignal" or tok[0]=="rule-nextSignal") {
   string[] list=new string[0];
   Signal[] slist=World.GetSignalList();
   int i;
   for (i=0; i<slist.size(); i++) {
    if (slist[i].GetName()!="") {
     list[list.size()]=slist[i].GetName();
    }
   }
   return list;
  }
  if (tok[0]=="junc") {
   Junction[] jlist=World.GetJunctionList();
   string[] list=new string[0];
   int i;
   for (i=0; i<jlist.size(); i++) {
    list[i]=jlist[i].GetName();
   }
   return list;
  }
  if (tok[0]=="defaultLimit" or tok[0]=="rule-limit") {
   int i;
   if (settings.GetNamedTagAsInt("speed-1")) { list[list.size()]=ST.GetString("fahrt.-1"); }
   if (settings.GetNamedTagAsInt("speed100")) { list[list.size()]=ST.GetString("fahrt.100"); }
   if (settings.GetNamedTagAsInt("speed60")) { list[list.size()]=ST.GetString("fahrt.60"); }
   if (settings.GetNamedTagAsInt("speed40")) { list[list.size()]=ST.GetString("fahrt.40"); }
   if (settings.GetNamedTagAsInt("speedRa12")) { list[list.size()]=ST.GetString("fahrt.Ra12"); }
   if (settings.GetNamedTagAsInt("speedZs1")) { list[list.size()]=ST.GetString("fahrt.Zs1"); }
   if (settings.GetNamedTagAsInt("speedZs8")) { list[list.size()]=ST.GetString("fahrt.Zs8"); }
   if (settings.GetNamedTagAsInt("speed0")) { list[list.size()]=ST.GetString("fahrt.0"); }
  }
  return list;
 }

 public void SetPropertyValue(string id, int val) {
  string[] tok=Str.Tokens(id,"/");
  if (tok[0]=="maxSpeed") {
   maxSpeed=val;
   speedlimits[SPEED_FULL]=maxSpeed;
  }
 }

 public void SetPropertyValue(string id, string val) {
  string[] tok=Str.Tokens(id,"/");

  if (tok[0]=="defaultLimit") {
   if (val==ST.GetString("fahrt.-1")) { defaultLimit=SPEED_FULL; }
   else if (val==ST.GetString("fahrt.100")) { defaultLimit=SPEED_100; }
   else if (val==ST.GetString("fahrt.60")) { defaultLimit=SPEED_60; }
   else if (val==ST.GetString("fahrt.40")) { defaultLimit=SPEED_40; }
   else if (val==ST.GetString("fahrt.Ra12")) { defaultLimit=SPEED_Ra12; }
   else if (val==ST.GetString("fahrt.Zs1")) { defaultLimit=SPEED_Zs1; }
   else if (val==ST.GetString("fahrt.Zs8")) { defaultLimit=SPEED_Zs8; }
   else if (val==ST.GetString("fahrt.0")) { defaultLimit=SPEED_0; }
   PostMessage(me,"HLSignal","Update",0);
  }
  if (tok[0]=="rule-limit") {
   int r=Str.ToInt(tok[1]);
   if (val==ST.GetString("fahrt.-1")) { rules[r].limit=SPEED_FULL; }
   else if (val==ST.GetString("fahrt.100")) { rules[r].limit=SPEED_100; }
   else if (val==ST.GetString("fahrt.60")) { rules[r].limit=SPEED_60; }
   else if (val==ST.GetString("fahrt.40")) { rules[r].limit=SPEED_40; }
   else if (val==ST.GetString("fahrt.Ra12")) { rules[r].limit=SPEED_Ra12; }
   else if (val==ST.GetString("fahrt.Zs1")) { rules[r].limit=SPEED_Zs1; }
   else if (val==ST.GetString("fahrt.Zs8")) { rules[r].limit=SPEED_Zs8; }
   else if (val==ST.GetString("fahrt.0")) { rules[r].limit=SPEED_0; }
   PostMessage(me,"HLSignal","Update",0);
  }
  if (tok[0]=="nextSignal") {
   nextSignalName=val;
   nextSignal=cast<Signal>Router.GetGameObject(val);
   nextSignalScripted=false;
   SubscribeTo(nextSignal);
   PostMessage(me,"HLSignal","Update",0);
  }
  if (tok[0]=="rule-nextSignal") {
   int r=Str.ToInt(tok[1]);
   rules[r].nextSignalName=val;
   rules[r].nextSignal=cast<Signal>Router.GetGameObject(val);
   rules[r].nextSignalScripted=false;
   SubscribeTo(rules[r].nextSignal);
   PostMessage(me,"HLSignal","Update",0);
  }
  if (tok[0]=="junc") {
   int r=Str.ToInt(tok[1]);
   int j=Str.ToInt(tok[2]);
   rules[r].njunc[j]=val;
   rules[r].junc[j]=cast<Junction>Router.GetGameObject(val);
   PostMessage(me,"HLSignal","Update",0);
  }
  if (tok[0]=="name") {
   name=val;
   if (name=="") {SetFXNameText("name0"," ");} else {SetFXNameText("name0",name);}
  }
 }

 public void SetPropertyValue(string id, string val, int idx) {
  SetPropertyValue(id,val);
 }

 public void LinkPropertyValue(string id) {
  string[] tok=Str.Tokens(id,"/");
  if (tok[0]=="add-rule") {
   rules[rules.size()]=new JRule();
  }
  if (tok[0]=="add-junc") {
   int r=Str.ToInt(tok[1]);
   int n=rules[r].njunc.size();
   rules[r].njunc[n]="";
   rules[r].junc[n]=null;
   rules[r].dir[n]=Junction.DIRECTION_NONE;
  }
  if (tok[0]=="del-rule") {
   int r=Str.ToInt(tok[1]);
   rules[r,r+1]=null;
  }
  if (tok[0]=="del-junc") {
   int r=Str.ToInt(tok[1]);
   int j=Str.ToInt(tok[2]);
   rules[r].junc[j,j+1]=null;
   rules[r].njunc[j,j+1]=null;
   rules[r].dir[j,j+1]=null;
  }
  if (tok[0]=="dir") {
   int r=Str.ToInt(tok[1]);
   int j=Str.ToInt(tok[2]);
   int d=Str.ToInt(tok[3]);
   rules[r].dir[j]=d;
  }
  if (tok[0]=="zs7") {
   zs7=!zs7;
   PostMessage(me,"HLSignal","Update",0);
  }
  if (tok[0]=="rule-zs7") {
   int r=Str.ToInt(tok[1]);
   rules[r].zs7=!rules[r].zs7;
   PostMessage(me,"HLSignal","Update",0);
  }
 }

 public string GetPropertyName(string id) {
  string[] tok=Str.Tokens(id,"/");
  if (tok[0]=="nextSignal") { return ST.GetString("nextSignal"); }
  else if (tok[0]=="rule-nextSignal") { return ST.GetString("nextSignal"); }
  else if (tok[0]=="rule-limit") { return ST.GetString("defaultlimit"); }
  else if (tok[0]=="defaultLimit") { return ST.GetString("defaultlimit"); }
  else if (tok[0]=="junc") { return ST.GetString("junction"); }
  else if (tok[0]=="name") { return ST.GetString("platetext"); }
  else if (tok[0]=="maxSpeed") { return ST.GetString("max.speed"); }
  return "";
 }

 public string GetPropertyDescription(string id) {

  return "";
 }

 public Soup GetProperties(void) {
  Soup db=inherited();
  db.SetNamedTag("name",name);
  db.SetNamedTag("defaultLimit",defaultLimit);
  db.SetNamedTag("nextSignal",nextSignalName);
  db.SetNamedTag("zs7",zs7);
  db.SetNamedTag("maxSpeed",maxSpeed);
  db.SetNamedTag("rules.num",rules.size());
  int i;
  for (i=0; i<rules.size(); i++) {
   db.SetNamedSoup("rule."+i,rules[i].GetProperties());
  }
  return db;
 }

 public void SetProperties(Soup db) {
  name=db.GetNamedTag("name");
  defaultLimit=db.GetNamedTagAsInt("defaultLimit",0);
  nextSignalName=db.GetNamedTag("nextSignal");
  if (db.GetNamedTag("maxSpeed")=="") { maxSpeed=-1; }
  else { maxSpeed=db.GetNamedTagAsInt("maxSpeed");}
  speedlimits[SPEED_FULL]=maxSpeed;
  zs7=db.GetNamedTagAsInt("zs7");
  int n=db.GetNamedTagAsInt("rules.num");
  rules=new JRule[n];
  int i;
  for (i=0; i<n; i++) {
   rules[i]=new JRule();
   rules[i].SetProperties(db.GetNamedSoup("rule."+i));
  }
  PostMessage(me,"HLSignal","Setup",0);
 }

 thread void HandleMB(void) {
   Message msg;
   while (mb) {
    wait() {
     on "Browser-URL","",msg: {
      if (msg.src==mb) {
       if (msg.minor=="live://repair-red") { ersatzrot=false; PostMessage(me,"HLSignal","Update",0); mb=null; }
      }
     }
     on "Browser-Closed","",msg: {
      if (msg.src==mb) { mb=null; }
     }
    }
   }
 }

 void ViewDetails(Message msg) {
  if (ersatzrot) {
   mb=Constructors.NewBrowser();
   mb.LoadHTMLString("<HTML><BODY><font color=#000000>HL-Hauptsignal:<BR><B>Hauptrot durchgebrannt</B><br></Font> "+HTMLWindow.MakeLink("live://repair-red","<font color=#FF0000>Reparieren</font>")+"</BODY></HTML>");
   HandleMB();
  }
 }

 public void Init(void) {
  inherited();
  Asset self=GetAsset();
  settings=self.GetConfigSoup().GetNamedSoup("extensions");
  ST=self.GetStringTable();
  rotlicht=self.FindAsset("HL-Red");
  gelblicht=self.FindAsset("HL-White");
  gruenlicht=self.FindAsset("HL-White");
  weisslicht=self.FindAsset("HL-White");
  name="A";
  SwitchOffAllLights();
  if (gruenlicht==null or gelblicht==null or rotlicht==null or weisslicht==null) {
   Interface.Log("Mindestens ein Corona-Asset fehlt!");
   return;
  }
  defaultLimit=SPEED_FULL;
  maxSpeed=-1;


  speedlimits[SPEED_FULL]=maxSpeed;
  speedlimits[SPEED_100]=100;
  speedlimits[SPEED_60]=60;
  speedlimits[SPEED_40]=40;
  speedlimits[SPEED_0]=0;
  speedlimits[SPEED_Zs1]=40;
  speedlimits[SPEED_Ra12]=25;
  speedlimits[SPEED_Zs8]=40;

  names[SPEED_FULL]="-1";
  names[SPEED_100]="100";
  names[SPEED_60]="60";
  names[SPEED_40]="40";
  names[SPEED_0]="0";
  names[SPEED_Zs1]="Zs1";
  names[SPEED_Ra12]="Ra12";
  names[SPEED_Zs8]="Zs8";

  AddHandler(me,"HLSignal","Setup","Setup");
  AddHandler(me,"HLSignal","Update","Update");
  AddHandler(me,"Signal","StateChanged","StateChange");
  AddHandler(me,"Junction","Toggled","JunctionToggled");
  AddHandler(me,"HLSignal","Subscribe","Subscribe");
  AddHandler(me,"HLSpeedNotify","","Notify");
  AddHandler(me,"MapObject","View-Details","ViewDetails");
  AddHandler(me,"KMAspectsChanged","","KMNotify");

 }

};